<?php

include "auth.php";

include_once(dirname(__FILE__) . '/vm/vm.php');
include_once(dirname(__FILE__) . '/inc/common.php');
include_once(dirname(__FILE__) . '/inc/util.php');
include_once(dirname(__FILE__) . '/config.php');

/* create another, temporary session-key. this is explained
   in [perform.php] */

if(!isset($_GET['key'])) {
  $_GET['key'] = '';
}

if($_GET['key'] == '') {
  Header('Location: ' . basename($_SERVER['PHP_SELF']) . '?' . build_query(array('key' => make_session_key()), array('PHPSESSID')));
}

/* clean up form data */
if(ini_get("magic_quotes_gpc")) {
  if(isset($_COOKIE['form'])) {
    $_COOKIE['form'] = stripslashes($_COOKIE['form']);
  }
}

/* load either from [settings.php] (cookie) or from session, if an error
   occured [perform.php] */

$form = array(
  'username' => '',
  'personal' => '',
  'forwards' => '',
  'expiry_year' => '',
  'expiry_month' => '',
  'expiry_day' => ''
);

if(isset($_SESSION['stored_forms'][$_GET['key']])) {
  $form = array_merge($form, &$_SESSION['stored_forms'][$_GET['key']]);
}
else if(isset($_COOKIE['form'])) {
  $form = array_merge($form, unserialize($_COOKIE['form']));
}

/* display page */
echo template_replace($parts['header'], array(
  'title'     => $language['add_alias']['title'],
  'character' => $language['language']['encoding']
));

echo template_replace($parts['add_alias_header'], array(
  'header'    => $language['add_alias']['header']
));

echo template_replace($parts['navigation'], array(
  'overview'    => $language['navigation']['overview'],
  'add_account' => $language['navigation']['add_account'],
  'add_alias'   => $language['navigation']['add_alias'],
  'settings'    => $language['navigation']['settings'],
  'logout'      => $language['navigation']['logout']
));

echo template_replace($parts['add_alias_form'], array(
  'key'                   => $_GET['key'],
  'domain'                => $_SESSION['domain'],
  'username'              => $form['username'],
  'personal'              => $form['personal'],
  'forwards'              => $form['forwards'],
  'expiry_year'           => $form['expiry_year'],
  'expiry_month'          => $form['expiry_month'],
  'expiry_day'            => $form['expiry_day'],
  'optional'              => $language['add_alias']['optional'],
  'title_user'            => $language['add_alias']['user'],
  'title_full_name'       => $language['add_alias']['full_name'],
  'title_password'        => $language['add_alias']['password'],
  'title_password_repeat' => $language['add_alias']['password_repeat'],
  'title_forwards'        => $language['add_alias']['forwards'],
  'forwards_text'         => $language['add_alias']['forwards_text'],
  'title_expiry'          => $language['add_alias']['expiry'],
  'title_expiry_year'     => $language['add_alias']['expiry_year'],
  'title_expiry_month'    => $language['add_alias']['expiry_month'],
  'title_expiry_day'      => $language['add_alias']['expiry_day'],
  'add_alias'             => $language['add_alias']['add_alias']
));

echo $parts['add_alias_footer'];

echo $parts['footer'];

?>
