<?php

include "auth.php";

include_once(dirname(__FILE__) . '/vm/vm.php');
include_once(dirname(__FILE__) . '/inc/common.php');
include_once(dirname(__FILE__) . '/inc/util.php');
include_once(dirname(__FILE__) . '/config.php');

/* vmailmgr interface */

$vm = new my_vmailmgr($_SESSION['domain'], rc4_decrypt($salt, $_SESSION['password']));

/* create another, temporary session-key. this is explained
   in [perform.php] */

if(!isset($_GET['key'])) {
  $_GET['key'] = '';
}

if($_GET['key'] == '') {
  Header('Location: ' . basename($_SERVER['PHP_SELF']) . '?' . build_query(array('key' => make_session_key()), array('username', 'PHPSESSID')));
}

/* load from session [peform.php] and make query to vmailmgr, where
   data returned from session has higher priority */

$form = $vm->user_info($_GET['username']);
$form['forwards'] = @join("\n", $form['forwards']);

if($form['expiry'] != '-') {
  $date = getdate($form['expiry']);
  $form['expiry_year']  = $date['year'];
  $form['expiry_month'] = $date['mon'];
  $form['expiry_day']   = $date['mday'];
} else {
  $form['expiry_year']  = '';
  $form['expiry_month'] = '';
  $form['expiry_day']   = '';
}

$form['account_enabled'] = $form['flags']['mailbox_enabled'];

/* forward */
if($form['mailboxdir'] == '') {

  if(isset($_SESSION['stored_forms'][$_GET['key']])) {
    $form = array_merge($form, $_SESSION['stored_forms'][$_GET['key']]);
  }

  /* display page */
  echo template_replace($parts['header'], array(
    'title'     => $language['edit_alias']['title'],
    'character' => $language['language']['encoding']
  ));

  echo template_replace($parts['edit_alias_header'], array(
    'header' => $language['edit_alias']['header']
  ));

  echo template_replace($parts['navigation'], array(
    'overview'    => $language['navigation']['overview'],
    'add_account' => $language['navigation']['add_account'],
    'add_alias'   => $language['navigation']['add_alias'],
    'settings'    => $language['navigation']['settings'],
    'logout'      => $language['navigation']['logout']
  ));

  echo template_replace($parts['edit_alias_form'], array(
    'key'                        => $_GET['key'],
    'domain'                     => $_SESSION['domain'],
    'username'                   => $form['username'],
    'type'                       => $language['edit_alias']['forward'],
    'account_enabled'            => $form['account_enabled']
                                    ? template_replace($parts['account_enabled'],  array('account_enabled' => $language['edit_alias']['enabled']))
                                    : template_replace($parts['account_disabled'], array('account_enabled' => $language['edit_alias']['enabled'])),
    'personal'                   => htmlentities($form['personal']),
    'forwards'                   => $form['forwards'],
    'expiry_year'                => $form['expiry_year'],
    'expiry_month'               => $form['expiry_month'],
    'expiry_day'                 => $form['expiry_day'],
    'title_user'                 => $language['edit_alias']['user'],
    'title_type'                 => $language['edit_alias']['type'],
    'title_account_enabled'      => $language['edit_alias']['account_enabled'],
    'title_full_name'            => $language['edit_alias']['full_name'],
    'title_password'             => $language['edit_alias']['password'],
    'title_password_repeat'      => $language['edit_alias']['password_repeat'],
    'password_text'              => $language['edit_alias']['password_text'],
    'title_forwards'             => $language['edit_alias']['forwards'],
    'forwards_text'              => $language['edit_alias']['forwards_text'],
    'title_expiry'               => $language['edit_alias']['expiry'],
    'title_expiry_year'          => $language['edit_alias']['expiry_year'],
    'title_expiry_month'         => $language['edit_alias']['expiry_month'],
    'title_expiry_day'           => $language['edit_alias']['expiry_day'],
    'save_changes'               => $language['edit_alias']['save_changes']
  ));

  echo $parts['edit_alias_footer'];

}
/* mailbox */
else {

  if($form['softquota'] == '-') {
    $form['softquota'] = '';
  }
  else {
    $form['softquota'] = round($form['softquota'] / BYTE_UNIT);
  }

  if($form['hardquota'] == '-') {
    $form['hardquota'] = '';
  }
  else {
    $form['hardquota'] = round($form['hardquota'] / BYTE_UNIT);
  }

  if($form['messagesize'] == '-') {
    $form['messagesize'] = '';
  }
  else {
    $form['messagesize'] = round($form['messagesize'] / BYTE_UNIT);
  }

  if($form['messagecount'] == '-') {
    $form['messagecount'] = '';
  }

  $form['autoresponse_enabled'] = $vm->autoresponse_isset($_GET['username']);

  $text = $vm->autoresponse_parse($vm->autoresponse_get($_GET['username']));
  if(isset($text['headers']['Subject'])) {
    $form['autoresponse_subject'] = $text['headers']['Subject'];
  } else {
    $form['autoresponse_subject'] = '';
  }
  $form['autoresponse_text']    = $text['body'];

  if(isset($_SESSION['stored_forms'][$_GET['key']])) {
    $form = array_merge($form, $_SESSION['stored_forms'][$_GET['key']]);
  }

  /* display page */
  echo template_replace($parts['header'], array(
    'title'     => $language['edit_account']['title'],
    'character' => $language['language']['encoding']
  ));

  echo template_replace($parts['edit_account_header'], array(
    'header' => $language['edit_account']['header']
  ));

  echo template_replace($parts['navigation'], array(
    'overview'    => $language['navigation']['overview'],
    'add_account' => $language['navigation']['add_account'],
    'add_alias'   => $language['navigation']['add_alias'],
    'settings'    => $language['navigation']['settings'],
    'logout'      => $language['navigation']['logout']
  ));

  echo template_replace($parts['edit_account_form'], array(
    'key'                        => $_GET['key'],
    'domain'                     => $_SESSION['domain'],
    'username'                   => $form['username'],
    'type'                       => $language['edit_account']['mailbox'],
    'account_enabled'            => $form['account_enabled']
                                    ? template_replace($parts['account_enabled'],  array('account_enabled' => $language['edit_account']['enabled']))
                                    : template_replace($parts['account_disabled'], array('account_enabled' => $language['edit_account']['enabled'])),
    'personal'                   => htmlentities($form['personal']),
    'forwards'                   => $form['forwards'],
    'softquota'                  => $form['softquota'],
    'hardquota'                  => $form['hardquota'],
    'messagesize'                => $form['messagesize'],
    'messagecount'               => $form['messagecount'],
    'expiry_year'                => $form['expiry_year'],
    'expiry_month'               => $form['expiry_month'],
    'expiry_day'                 => $form['expiry_day'],
    'autoresponse_enabled'       => $form['autoresponse_enabled']
                                    ? template_replace($parts['autoresponse_enabled'],  array('autoresponse_enabled' => $language['edit_account']['autoresponse_enabled']))
                                    : template_replace($parts['autoresponse_disabled'], array('autoresponse_enabled' => $language['edit_account']['autoresponse_enabled'])),
    'autoresponse_text'          => htmlentities($form['autoresponse_text']),
    'autoresponse_subject'       => htmlentities($form['autoresponse_subject']),
    'title_user'                 => $language['edit_account']['user'],
    'title_type'                 => $language['edit_account']['type'],
    'title_account_enabled'      => $language['edit_account']['account_enabled'],
    'title_full_name'            => $language['edit_account']['full_name'],
    'title_password'             => $language['edit_account']['password'],
    'title_password_repeat'      => $language['edit_account']['password_repeat'],
    'password_text'              => $language['edit_account']['password_text'],
    'title_forwards'             => $language['edit_account']['forwards'],
    'forwards_text'              => $language['edit_account']['forwards_text'],
    'title_softquota'            => $language['edit_account']['softquota'],
    'title_hardquota'            => $language['edit_account']['hardquota'],
    'title_message_size'         => $language['edit_account']['message_size'],
    'title_message_count'        => $language['edit_account']['message_count'],
    'title_expiry'               => $language['edit_account']['expiry'],
    'title_expiry_year'          => $language['edit_account']['expiry_year'],
    'title_expiry_month'         => $language['edit_account']['expiry_month'],
    'title_expiry_day'           => $language['edit_account']['expiry_day'],
    'title_autoresponse'         => $language['edit_account']['autoresponse'],
    'title_autoresponse_subject' => $language['edit_account']['autoresponse_subject'],
    'title_autoresponse_message' => $language['edit_account']['autoresponse_message'],
    'title_autoresponse_text'    => $language['edit_account']['autoresponse_text'],
    'save_changes'               => $language['edit_account']['save_changes']
  ));

  echo $parts['edit_account_footer'];

}

echo $parts['footer'];

?>
