<?php

include_once dirname(__FILE__) . '/../config.php';
include_once dirname(__FILE__) . '/templates.php';
include_once dirname(__FILE__) . '/languages.php';

/*
 *  Security check (administrator-laziness-check)
 */

if($salt == '') {
  die('<b>Security Alert</b>: vmmi will refuse to work until you have set a value for <b>$salt</b> in config.php');
}

/*
 *  PHP >= 4.1.0 checking
 */

if($php_version_checking && !(version_compare(phpversion(), $required = '4.1.0') >= 0)) {
  die('<b>Warning</b>: This PHP version (' . phpversion() . ') is too old. At least ' . $required . ' is required. You can disable this check by setting <b>$php_version_checking</b> to false in config.php');
}

/*
 *  Rather than having to go through all files in ./languages/ on every
 *  request (and having to parse out the language title), we define a list
 *  of all available languages. It's redundant, but it improves performance.
 */

$available_languages = array(
  'da' => 'Dansk',
  'de' => 'Deutsch',
  'en' => 'English',
  'fi' => 'Finnish',
  'fr' => 'Franais',
  'id' => 'Indonesian',
  'it' => 'Italiano',
  'pt' => 'Portugus',
  'sr' => 'Serbian',
  'es' => 'Spanish',
  'sv' => 'Svenska'
);

/*
 *  Do stuff that's common to all pages, such as parse language file,
 *  load template, ..
 */

$parts = template_parse(template_load($path = dirname(__FILE__) . '/../templates/' . $template . '/template.html'))
  or die("Could not load template '$path'");

/* values passed over by GET have priority */
if(@isset($available_languages[$_GET['lang']])) { /* the @ is necessary if a user makes a request like ?lang[]=en (i.e. passing an array to the script), which would produce an error message */
  $_SESSION['lang'] = $_GET['lang'];
  setcookie("lang", $_GET['lang']);
}
/* otherwise try to find a cookie */
else if(isset($_COOKIE['lang'])) {
  $_SESSION['lang'] = $_COOKIE['lang'];
}
/* if all fails, at least try to find out the user's preferred language [languages.php] */
else if(!isset($_SESSION['lang']) && ($_SESSION['lang'] = preferred_language(array_keys($available_languages))) === false) {
  $_SESSION['lang'] = 'en';
}

if(!isset($available_languages[$_SESSION['lang']])) {
  die("Invalid language file '" . $_SESSION['lang'] . "'");
}

if(($language = config_parse(@file($path = dirname(__FILE__) . '/../languages/' . $_SESSION['lang'] . '.lang'))) == '') {
  die("Could not load language file '$path'");
}

/*
 *  vmmi displays Quotas in KB (divided by 1024). Shouldn't be changed. I just
 *  didn't want to have a bunch of "magic numbers" in the source code.
 */ 

define('BYTE_UNIT', 1024);

?>
