<?php

/*
 * Template functions
 * 
 * Authors:
 *   Daniel Lorch <daniel@lorch.cc> 2001
 *
 */

/* load $file and return as string */
function template_load($file) {
  if(!file_exists($file))
    return false;

  $fp=fopen($file, "r");
  $t=fread($fp, filesize($file));
  fclose($fp);

  return $t;
}

/* replace {elements} */
function template_replace($s, $replacements=array()) {
  foreach($replacements as $before => $after)
    $s = str_replace("{".$before."}", $after, $s);

  return $s;
}

/* split a template file into parts */
function template_parse($s) {
  preg_match_all("'<!--\s*BEGIN +([a-z0-9\-_]+)\s*-->\n(.*?)\n<!--\s*END +\\1\s*-->'is", $s, $matches, PREG_PATTERN_ORDER);

  for($i=0; $i<count($matches[1]); ++$i) {
    $result[$matches[1][$i]] = $matches[2][$i];
  }
  
  return $result;
}

?>
