<?php

include "auth.php";

include_once(dirname(__FILE__) . '/vm/vm.php');
include_once(dirname(__FILE__) . '/inc/common.php');
include_once(dirname(__FILE__) . '/inc/util.php');
include_once(dirname(__FILE__) . '/config.php');

/* clean up form data */
if(ini_get("magic_quotes_gpc")) {
  if(isset($_COOKIE['form'])) {
    $_COOKIE['form'] = stripslashes($_COOKIE['form']);
  }
}

/* load settings */
if(isset($_COOKIE['form'])) {
  $form = unserialize($_COOKIE['form']);
} else {
  $form = array(
    'personal' => '',
    'forwards' => '',
    'softquota' => '',
    'hardquota' => '',
    'messagesize' => '',
    'messagecount' => '',
    'expiry_year' => '',
    'expiry_month' => '',
    'expiry_day' => ''
  );
}

/* display page */
echo template_replace($parts['header'], array(
  'title'     => $language['settings']['title'],
  'character' => $language['language']['encoding']
));

echo template_replace($parts['settings_header'], array(
  'header'    => $language['settings']['header']
));

echo template_replace($parts['navigation'], array(
  'overview'    => $language['navigation']['overview'],
  'add_account' => $language['navigation']['add_account'],
  'add_alias'   => $language['navigation']['add_alias'],
  'settings'    => $language['navigation']['settings'],
  'logout'      => $language['navigation']['logout']
));

echo template_replace($parts['settings_form'], array(
  'personal'            => $form['personal'],
  'forwards'            => $form['forwards'],
  'softquota'           => $form['softquota'],
  'hardquota'           => $form['hardquota'],
  'messagesize'         => $form['messagesize'],
  'messagecount'        => $form['messagecount'],
  'expiry_year'         => $form['expiry_year'],
  'expiry_month'        => $form['expiry_month'],
  'expiry_day'          => $form['expiry_day'],
  'notice'              => $language['settings']['notice'],
  'title_full_name'     => $language['settings']['full_name'],
  'title_forwards'      => $language['settings']['forwards'],
  'forwards_text'       => $language['settings']['forwards_text'],
  'title_softquota'     => $language['settings']['softquota'],
  'title_hardquota'     => $language['settings']['hardquota'],
  'title_message_size'  => $language['settings']['message_size'],
  'title_message_count' => $language['settings']['message_count'],
  'title_expiry'        => $language['settings']['expiry'],
  'title_expiry_year'   => $language['settings']['expiry_year'],
  'title_expiry_month'  => $language['settings']['expiry_month'],
  'title_expiry_day'    => $language['settings']['expiry_day'],
  'defaults'            => $language['settings']['defaults']
));

echo $parts['settings_footer'];

echo $parts['footer'];

?>
