<?php

include "auth.php";

include_once(dirname(__FILE__) . '/vm/vm.php');
include_once(dirname(__FILE__) . '/inc/common.php');
include_once(dirname(__FILE__) . '/inc/util.php');
include_once(dirname(__FILE__) . '/config.php');

/* create another, temporary session-key. this is explained
   in [perform.php] */

if(!isset($_GET['key'])) {
  $_GET['key'] = '';
}

if($_GET['key'] == '') {
  Header('Location: ' . basename($_SERVER['PHP_SELF']) . '?' . build_query(array('key' => make_session_key()) , array('PHPSESSID')));
}

/* vmailmgr interface */
$vm = new my_vmailmgr($_SESSION['domain'], rc4_decrypt($salt, $_SESSION['password']));

$skel = array(
  'username' => '',
  'personal' => '',
  'forwards' => '',
  'softquota' => '',
  'hardquota' => '',
  'messagesize' => '',
  'messagecount' => '',
  'expiry_year' => '',
  'expiry_month' => '',
  'expiry_day' => '',
  'autoresponse_enabled' => ''
);

/* if we were sent back by [perform.php], load from session */
if(isset($_SESSION['stored_forms'][$_GET['key']])) {
  $form = &$_SESSION['stored_forms'][$_GET['key']];
} else {
  $form = array();
}

/* load template */
$parts = template_parse(template_load($path = "templates/" . $template . "/template.html"))
  or die("Could not load template '$path'");
  
if(($info = $vm->user_info($_SESSION['user'])) === false) {
  echo "<b>Fatal Error</b>: Could not list user";
}
else {

  $info = array_merge($skel, $info);

  /* forward */
  if($info['mailboxdir'] == '') {

    /* display page */
    echo template_replace($parts['header'], array(
      'title'     => $language['user_alias']['title'],
      'character' => $language['language']['encoding']
    ));

    if($info['expiry'] == '-') {
      $info['expiry'] = '-';
    }
    else {
      $date = getdate($info['expiry']);
    
      $info['expiry'] = template_replace($language['user']['expiry_format'], array(
        'year'  => $date['year'],
        'month' => sprintf("%02d", $date['mon']),
        'day'   => sprintf("%02d", $date['mday'])
       ));
    }

    /* data returned from form have higher priority */
    $info = array_merge($info, $form);

    echo template_replace($parts['user_alias_header'], array(
      'header'    => $language['user_alias']['header']
    ));

    echo template_replace($parts['user_alias_form'], array(
      'key'                        => $_GET['key'],
      'username'                   => $info['username'],
      'domain'                     => $_SESSION['domain'],
      'type'                       => $language['user_alias']['forward'],
      'personal'                   => htmlentities($info['personal']),
      'forwards'                   => $info['forwards'],
      'expiry'                     => $info['expiry'],
      'title_user'                 => $language['user_alias']['user'],
      'title_type'                 => $language['user_alias']['type'],
      'title_full_name'            => $language['user_alias']['full_name'],
      'title_password'             => $language['user_alias']['password'],
      'title_password_repeat'      => $language['user_alias']['password_repeat'],
      'password_text'              => $language['user_alias']['password_text'],
      'title_forwards'             => $language['user_alias']['forwards'],
      'forwards_text'              => $language['user_alias']['forwards_text'],
      'title_expiry'               => $language['user_alias']['expiry'],
      'save_changes'               => $language['user_alias']['save_changes'],
      'logout'                     => $language['user_alias']['logout']
    ));

    echo $parts['user_alias_footer'];
  }
  /* mailbox */
  else {

    /* display page */
    echo template_replace($parts['header'], array(
      'title'     => $language['user_account']['title'],
      'character' => $language['language']['encoding']
    ));

    $info['hardquota']    = $info['hardquota'] == '-'    ? '-' : format_filesize($info['hardquota']);
    $info['softquota']    = $info['softquota'] == '-'    ? '-' : format_filesize($info['softquota']);
    $info['messagesize']  = $info['messagesize'] == '-'  ? '-' : format_filesize($info['messagesize']);
    $info['messagecount'] = $info['messagecount'] == '-' ? '-' : $info['messagecount'];
    $info['forwards']     = @join("\n", $info['forwards']);

    $info['autoresponse_enabled'] = $vm->autoresponse_isset($_SESSION['user']);
  
    $text = $vm->autoresponse_parse($vm->autoresponse_get($_SESSION['user']));
    if(isset($text['headers']['Subject'])) {
      $info['autoresponse_subject'] = $text['headers']['Subject']; // == '' ? 'Vorlage' : '';
    } else {
      $info['autoresponse_subject'] = '';
    }
    $info['autoresponse_text']    = $text['body']; // == '' ? 'Autoresponder-Vorlage' : '';

    if($info['expiry'] == '-') {
      $info['expiry'] = '-';
    }
    else {
      $date = getdate($info['expiry']);
    
      $info['expiry'] = template_replace($language['user_account']['expiry_format'], array(
        'year'  => $date['year'],
        'month' => sprintf("%02d", $date['mon']),
        'day'   => sprintf("%02d", $date['mday'])
       ));
    }
    
    /* data returned from form have higher priority */
    $info = array_merge($info, $form);

    echo template_replace($parts['user_account_header'], array(
      'header'    => $language['user_account']['header']
    ));

    echo template_replace($parts['user_account_form'], array(
      'key'                        => $_GET['key'],
      'username'                   => $info['username'],
      'domain'                     => $_SESSION['domain'],
      'type'                       => $language['user_account']['mailbox'],
      'personal'                   => htmlentities($info['personal']),
      'forwards'                   => $info['forwards'],
      'softquota'                  => $info['softquota'],
      'hardquota'                  => $info['hardquota'],
      'messagesize'                => $info['messagesize'],
      'messagecount'               => $info['messagecount'],
      'expiry'                     => $info['expiry'],
      'autoresponse_enabled'       => $info['autoresponse_enabled'] ? $parts['autoresponse_enabled'] : $parts['autoresponse_disabled'],
      'autoresponse_text'          => htmlentities($info['autoresponse_text']),
      'autoresponse_subject'       => htmlentities($info['autoresponse_subject']),
      'title_user'                 => $language['user_account']['user'],
      'title_type'                 => $language['user_account']['type'],
      'title_full_name'            => $language['user_account']['full_name'],
      'title_password'             => $language['user_account']['password'],
      'title_password_repeat'      => $language['user_account']['password_repeat'],
      'password_text'              => $language['user_account']['password_text'],
      'title_forwards'             => $language['user_account']['forwards'],
      'forwards_text'              => $language['user_account']['forwards_text'],
      'title_softquota'            => $language['user_account']['softquota'],
      'title_hardquota'            => $language['user_account']['hardquota'],
      'title_message_size'         => $language['user_account']['message_size'],
      'title_message_count'        => $language['user_account']['message_count'],
      'title_expiry'               => $language['user_account']['expiry'],
      'title_autoresponse'         => $language['user_account']['autoresponse'],
      'autoresponse_enabled'       => $info['autoresponse_enabled']
                                      ? template_replace($parts['autoresponse_enabled'], array('autoresponse_enabled' => $language['edit_account']['autoresponse_enabled']))
                                      : template_replace($parts['autoresponse_disabled'], array('autoresponse_enabled' => $language['edit_account']['autoresponse_enabled'])),
      'title_autoresponse_subject' => $language['user_account']['autoresponse_subject'],
      'title_autoresponse_message' => $language['user_account']['autoresponse_message'],
      'title_autoresponse_text'    => $language['user_account']['autoresponse_text'],
      'save_changes'               => $language['user_account']['save_changes'],
      'logout'                     => $language['user_account']['logout']
    ));

    echo $parts['user_account_footer'];

  }
}


echo $parts['footer'];
?>
